/*
 * IntegerKey.java
 *
 * Created on July 23, 2001, 1:08 PM
 */


package Keys;

/**
 *
 * @author  hansen
 * @version 
 */
public class IntegerKey implements Key {

    private Integer key = new Integer(0);
    
    /** Gets the key value */
    public Integer getValue() {
        return key;
    }
    
    /** Creates new IntegerKey */
    public IntegerKey() {
    }

    /** Construct a Key object with value k */
    public IntegerKey (int k) {
        key = new Integer(k);
    }
    
    /** the easiest constructor */
    public IntegerKey (Integer k) {
        key = k;
    }
    
    /** Convert a Key to a string */
    public String toString()
    {
        return getValue().toString();
    }
    
    /** Returns true if key equals k */
    public boolean equals(Key k) {
        return (key.intValue() == ((IntegerKey)k).getValue().intValue());
    }

    /** Returns true if key < k */
    public boolean lt (Key k) {
        return (key.intValue() < ((IntegerKey)k).getValue().intValue());
    }
    
    /** Returns true if key > k */
    public boolean gt (Key k) {
        return (key.intValue() > ((IntegerKey)k).getValue().intValue());
    }
    
    /** Returns true of key <= k */
    public boolean le (Key k) {
        return (key.intValue() <= ((IntegerKey)k).getValue().intValue());
    }
    
    /** Returns true if key >= k */
    public boolean ge (Key k) {
        return (key.intValue() >= ((IntegerKey)k).getValue().intValue());
    }
     
}