/*
 * Key.java
 *
 * Created on July 23, 2001, 1:05 PM
 *
 * We have to be able to compare keys to build a BST
 * so all key types must implement these methods.
 *
 * @author  Stuart Hansen
 */

package Keys;

/** This interface is for all keys for the optimal binary tree project */
public interface Key {
    
    /** Returns true if the object is equal to k */
    public boolean equals(Key k);
    
    /** Returns true if the object is less than k */
    public boolean lt (Key k);
    
    /** Returns true if the object is greater than k */
    public boolean gt (Key k);
    
    /** Returns true if the object is less than or equal to k */
    public boolean le (Key k);
    
    /** Returns true if the object is greater than or equal to k */
    public boolean ge (Key k);
}

