package Nodes;

/*
 * INode.java
 * INodes are the interface that all node classes must implement.
 *
 * Created on May 8, 2001, 10:19 AM
 * @author  Stuart Hansen
 */

import Keys.*;

public interface INode {
    /** Each node must know how to search the subtree that it roots */
    abstract boolean search(Key search_key);

    /** Each node knows how to insert into the subtree it roots */
    abstract INode insert (Key newkey);
    
    /** Each node must know how to do an inorder traveral of the tree it roots*/
    void inOrder();
    
    /** Each node must know how to do a preorder traversal of the tree it roots */
    void preOrder();
    
    /** setLeft sets the left subtree of this node to the argument */
    void setLeft(INode left);
    
    /** setRight sets the right subtree of this node to the argument */
    void setRight(INode right);
}
