package Nodes;
/*
 * LRangeNode.java
 * Range nodes where the left key is checked first when searching.
 *
 * Created on September 4, 2001, 11:55 AM
 * @author  Stuart Hansen 
 */

import Keys.*;

public class LRangeNode extends RangeNode {
    
    /** Nodes only exist if they have values to go in them */
    public LRangeNode(Key left_key, Key right_key) {
        super(left_key, right_key);
    }
    
    /** This constructor assumes the left and right subtrees already exist */
    public LRangeNode (Key left_key, Key right_key, INode left, INode right) {
        super(left_key, right_key, left, right);
    }

        /** translate this node into a string */
    public String toString() {
        return ("LRange" + left_key + "-" + right_key);
    }
    
    /** Search the subtree rooted at this node for the search_key */
    public boolean search (Key search_key) {
        if (!(search_key.gt(left_key)))
            return left.search(search_key);
        else if (!(search_key.lt(right_key)))
            return right.search (search_key);
        else 
            return false;
    }
    
}
