package Nodes;

/*
 * LeafNode.java
 * A class for nodes with a key but no subtrees.
 *
 * Created on July 22, 2002, 3:33 PM
 * @author  Stuart Hansen
 * @version 
 */

import Keys.*;

public class LeafNode implements INode
{

    Key key;     // the Key
    
    /** Creates new NoKidsNode */
    public LeafNode(Key key) {
        this.key = key;
    }

    /** Each node must know how to search the subtree that it roots  */
    public boolean search(Key search_key) {
        return true;
    }
    
    /** Each node knows how to insert into the subtree it roots  */
    public INode insert(Key newkey) {
        INode p;
        if (newkey.gt(key)) {
            p = new ROnlyNode(key, new LeafNode(newkey));  
        }    
        else {
            p = new LOnlyNode(key, new LeafNode(newkey));
        }
        return p;
        // Note we are disallowing key equality.  This would break the above code.    
    }
    
    /** Each node must know how to do an inorder traveral of the tree it roots */
    public void inOrder() {
        System.out.print(this.toString());
    }
    
    /** Each node must know how to do a preorder traversal of the tree it roots  */
    public void preOrder() {
        System.out.print(this.toString());
    }

        /** setLeft is illegal in LeafNodes */
    public void setLeft (INode left) {
        System.out.println ("NullNodes cannot contain subtrees.");
    }
    
    /** setRight is illegal in LeafNodes */
    public void setRight(INode right) {
        System.out.println ("NullNodes cannot contain subtrees.");
    }
    
    public String toString() {
        return " Leaf"+key.toString();
    }
}
