package Nodes;
/*
 * NNode.java
 * NNodes are for root heavy trees.  It checks the root first when searching.
 *
 * Created on September 4, 2001, 11:58 AM
 * @author  Stuart Hansen 
 */

import Keys.*;

public class NNode extends Node{

    /** Nodes only exist if they have values to go in them */
    public NNode (Key value) {
        super(value);
    }
    
    /** Insert a new node with given subtrees */
    public NNode (Key value, INode left, INode right) {
        super (value, left, right);
    }

        /** Convert a node to a string */
    public String toString () {
        return "N" + key.toString();
    }

    /** Search the subtree rooted at this node for the search_key */
    public boolean search (Key search_key) {
        System.out.println ("Searching " + this);
        if (search_key.equals(key))
            return true;
        else if (search_key.gt(key))
            return right.search (search_key);
        else 
            return left.search(search_key);
    }

}
