package Nodes;
/*
 * RNode.java
 * RNodes are for right heavy trees.  It checks the right branch of the 
 * tree first when searching.
 *
 * Created on September 4, 2001, 11:57 AM
 * @author  Stuart Hansen
 * @version 
 */

import Keys.*;

public class RNode extends Node {

    /** Nodes only exist if they have values to go in them */
    public RNode (Key value) {
        super(value);
    }
    
    /** Insert a new node with given subtrees */
    public RNode (Key value, INode left, INode right) {
        super (value, left, right);
    }

        /** Convert a node to a string */
    public String toString () {
        return "R" + key.toString();
    }

    /** Search the subtree rooted at this node for the search_key */
    public boolean search (Key search_key) {
        System.out.println ("Searching " + this);
        if (search_key.gt(key))
            return right.search(search_key);
        else if (search_key.lt(key))
            return left.search (search_key);
        else 
            return true;
    }

}
