package Nodes;
/*
 * ROnlyNode.java
 * A class for nodes with a key and only a right subtree.
 *
 * Created on July 22, 2002, 3:32 PM
 * @author  Stuart Hansen 
 */

import Keys.*;

public class ROnlyNode implements INode {
    
    private Key key;
    private INode right;
    
    /** Creates new ROneNode */
    public ROnlyNode(Key key, INode right) {
        this.key = key;
        this.right = right;
    }

        /** Each node must know how to search the subtree that it roots  */
    public boolean search(Key search_key) {
        if (search_key.equals(key))
            return true;
        else
            return right.search(search_key);
    }
    
    /** Each node knows how to insert into the subtree it roots  */
    public INode insert(Key newkey) {
        if (newkey.gt(key)) {
            right = right.insert(newkey);
            return this;
        }
        else {
            INode p = new LeafNode(newkey);
            INode me = new Node(key, p, right);
            return me;
        }   
    }

    /** setLeft sets the left subtree of this node */
    public void setLeft (INode left) {
        System.out.println("It is illegal to setLeft on a ROnlyNode");
    }
    
    /** setRight sets the right subtree of this node */
    public void setRight (INode right) {
        this.right = right;
    }
    /** Each node must know how to do an inorder traveral of the tree it roots */
    public void inOrder() {
        System.out.print (" (");
        System.out.print (this);
        right.inOrder();
        System.out.print(")");
    }
    
    /** Each node must know how to do a preorder traversal of the tree it roots  */
    public void preOrder() {
        System.out.print (" (" + this);
        right.preOrder();
        System.out.print(")");
    } 
    
    public String toString () {
        return ("RO" + key.toString());
    }

}
