package Nodes;
/*
 * RRangeNode.java
 * RRangeNodes are for right heavy trees.  The right key is checked first
 * when searching.
 *
 * Created on September 4, 2001, 11:56 AM
 * @author  Stuart Hansen
 * @version 
 */

import Keys.*;

public class RRangeNode extends RangeNode {

    /** Nodes only exist if they have values to go in them */
    public RRangeNode(Key left_key, Key right_key) {
        super(left_key, right_key);
    }
    
    /** This constructor assumes the left and right subtrees already exist */
    public RRangeNode (Key left_key, Key right_key, INode left, INode right) {
        super(left_key, right_key, left, right);
    }

    /** translate this node into a string */
    public String toString() {
        return ("RRange" + left_key + "-" + right_key);
    }
    
    /** Search the subtree rooted at this node for the search_key */
    public boolean search (Key search_key) {
        System.out.println ("Searching " + this);
        if (!(search_key.lt(right_key)))
            return right.search(search_key);
        else if (!(search_key.gt(left_key)))
            return left.search (search_key);
        else 
            return false;
    }
    
}
