/*
 * BST.java
    * This file implements simple binary search trees using NullNodes.
 * Created on September 16, 2001, 11:54 AM
 * @author  Stuart Hansen 
 */

import java.io.*;
import java.util.*;
import Keys.*;
import Nodes.*;

public class SimpleBST {

    INode root;  // The root of the tree
    KeyTokenizer reader;
    
    /** Creates new Binary Tree */
    public SimpleBST(KeyTokenizer kt) {
        root = NullNode.getInstance();
        reader = kt;
    }

    /** Reads the key values from an unsorted file and
     *  builds a binary search tree */
    public void buildFromFile () { 
        while (reader.hasNext()) {                
            root = root.insert(reader.getNext());
        }
    }

    /** search the tree starting at the root */
    public boolean search (IntegerKey search_key) {
        return root.search(search_key);
    }
    
    /** Traverse the tree printing out each element */
    public void inOrder() {
        root.inOrder();
    }
    
    /** Traverse the tree in preOrder printing out as we go */
    public void preOrder() {
        root.preOrder();
    }


    /** a test main for this class (and its subclasses) */
    public static void main (String args[])
    {
        SimpleBST bst = new SimpleBST(new IntKeyTokenizer(
                          "/home/hansen/Research/optimalBST/data/bst.dat"));
        bst.buildFromFile();
        bst.preOrder();
    }                
}

